<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<title>math operator</title>
</head>
<body>

<?php
// Pre-increment
echo "Pre-increment example: 5 incremented by 1 <br>";
$num = 5;
echo ++$num." (Already incremented by 1)<br>"; // prints 6. $num is first incremented by 1 and then returns the new value
echo $num; // prints 6
echo "<br><br>";


// Post-increment
echo "Post-increment example: 5 incremented by 1 <br>";
$num = 5;
echo $num++." (Not yet incremented. It is still 5)<br>"; // prints 5. $num is still 5, not yet incremented.
/* Why? This step increments $num by 1 but it returns the original value. 
The new value is copied to an internal temporary variable, which creates an overhead. Because of 
the temporary variable, the post-increment is 10% slower than pre-increment. 
 */
echo $num." (Now it is incremented by 1)"; // prints 6. Now the new value is returned to $num. 
echo "<br><br>";


//Post-increment (not a good example)
echo "This will not work for post-increment<br>";
$num = 5;
$new_num = $num++; // this step assigns the current value of $num (whichi is 5) to $new_num. $new_num gets the value 5, not 6
echo $new_num." (This will not work)<br>"; // prints 5. Does not increment Since the value of $new_num is fixed at 5, this line will print 5.
echo $new_num." (This will not work)<br>"; // prints 5. Does not increment. This line does the same thing, because $new_num has not changed.
echo "<br><br>";
?>
</body>
</html>
